<template>
  <div 
    v-if="isExternalIcon" 
    :style="styleExternalIcon" 
    class="svg-external-icon svg-icon"
    v-bind="$attrs"
  ></div>
  <svg 
    v-else 
    :class="svgClass" 
    aria-hidden="true"
    v-bind="$attrs"
  >
    <use :xlink:href="iconName" />
  </svg>
</template>

<script setup>
import { computed } from 'vue'


// 启用 inheritAttrs 选项
defineOptions({
  name: 'SvgIcon',
  inheritAttrs: false
})

// 定义 props
const props = defineProps({
  iconClass: {
    type: String,
    required: true
  },
  className: {
    type: String,
    default: ''
  }
})

 function isExternal(path) {
    return /^(https?:|mailto:|tel:)/.test(path)
}

// 计算属性
const isExternalIcon = computed(() => {
  return isExternal(props.iconClass)
})

const iconName = computed(() => {
  return `#icon-${props.iconClass}`
})

const svgClass = computed(() => {
  if (props.className) {
    return 'svg-icon ' + props.className
  } else {
    return 'svg-icon'
  }
})

const styleExternalIcon = computed(() => {
  return {
    mask: `url(${props.iconClass}) no-repeat 50% 50%`,
    '-webkit-mask': `url(${props.iconClass}) no-repeat 50% 50%`
  }
})
</script>

<style scoped>
.svg-icon {
  width: 1em;
  height: 1em;
  vertical-align: -0.15em;
  fill: currentColor;
  overflow: hidden;
}

.svg-external-icon {
  background-color: currentColor;
  mask-size: cover!important;
  display: inline-block;
}
</style>